// -------------------------------------------------------------
// 3d code by Georgy Moshkin (Delphi)
//
// v2008.1.2
//
// horse model by Damien McGinnes
// horse texture by Andor Holtzmark
// exgine.dll by XProger
//
// note:
// glTexCoord2f(u,v); 
// glTexCoord2f(u,1-v);
// -------------------------------------------------------------

program example;

uses
  OpenGL,eXgine,texture,skeleton,polygon,mesh,nftloader,strtool,render; //  eXgine


var mdl:TMeshes;
    skanim:TSkeletonAnimation;
    myts:TTextures;


// -=(    )=-
procedure Update;
begin
//    Escape (  27)
  if inp.Down(27) then eX.Quit;

end;

// -=(    )=-
procedure Render;
var i:integer;
begin
  glClearColor(0.3,0.3,0.3,1);
  ogl.Clear(true, true); //  
  ogl.Set3D(45, 0.1, 512); //    

  glTranslatef(0,-2,-7);
  glRotatef(-90,1,0,0);
  glRotatef(ex.GetTime/50,0,0,1);


  glEnable(GL_DEPTH_TEST);

for i:=0 to length(mdl)-1 do
      DrawPolys(mdl[i]);

  tex.Disable();
for i:=0 to length(mdl)-1 do
      DrawPolysWire(mdl[i]);

for i:=0 to length(mdl)-1 do
      DrawNormals(mdl[i]);

  ogl.Set2D(0, 0, wnd.Width, wnd.Height);
  tex.Disable();
  glColor3f(1, 1, 1);


(*
  for i:=0 to length(skanim.skeleton)-1 do
   begin
    ogl.TextOut(0, 8, 16*i, PChar(skanim.skeleton[i].name));
   end;
*)

  ogl.TextOut(0, 8, 16, 'NTF LOADER v2008.2.1 (NTF files produced by nft_export.py script for BLENDER)');
  ogl.TextOut(0, 8, 32, 'Source code for Delphi by Georgy Moshkin');


end;


// -=(   )=-
begin

  //    
  wnd.Create('NTF LOADER v2008.2.1 (NTF files produced by nft_export.py script for BLENDER)');

  //    ,     
  eX.SetProc(PROC_UPDATE, @Update);
  eX.SetProc(PROC_RENDER, @Render);

  //   log-
  log.Print('Hello World!');



   inp.MCapture(true); //  "" 

  //    
  wnd.Mode(False, 640, 480, 32, 75);

  loadnft('horse.nft',mdl,skanim,myts);
   
  //    
  eX.MainLoop(50);
end.

